//+------------------------------------------------------------------+
//|                                             Sentiment_all_v2.mq4 |
//+------------------------------------------------------------------+

#property copyright "OnTheRoad"
#property link      "ontheroad7069@yahoo.com"
//modified v sry1 for programming efficiency
// and to automatically refresh all pairs - all tf
//v sry2 moves calculation of MA coefficents to outer loop and stores in separate variables
//  so they only have to be calculated once per bar.
// then uses iMAOnArray Function to do the original MA calculations.

#define  MAX_CPAIRS  30
#define  MAX_SPAIRS  10

#define  EUR   0
#define  USD   1
#define  JPY   2
#define  GBP   3
#define  CAD   4
#define  CHF   5
#define  AUD   6
#define  NZD   7

#define  OIL   8
#define  GOLD  9

#property indicator_separate_window

#property indicator_buffers 8

#property indicator_color1 Red
#property indicator_color2 DarkViolet
#property indicator_color3 Chocolate
#property indicator_color4 Green
#property indicator_color5 DodgerBlue
#property indicator_color6 Aqua
#property indicator_color7 Chartreuse
#property indicator_color8 Gold

/*
color indicator_clr1 = Red;         //EUR
color indicator_clr2 = DarkViolet;  //USD
color indicator_clr3 = Chocolate;   //JPY
color indicator_clr4 = Green;       //GBP
color indicator_clr5 = DodgerBlue;  //CAD
color indicator_clr6 = Aqua;        //CHF
color indicator_clr7 = Chartreuse;  //AUD
color indicator_clr8 = Gold;        //NZD
*/

color indicator_color[]={Red,DarkViolet,Chocolate,Green,DodgerBlue,Aqua,Chartreuse,Gold};

//---- input parameters
extern int       MA_Per       = 3;
extern int       Flt_Per      = 2;
extern int       Candle_Back  = 1;
extern int       History      = 288;
// sry added to control pair refresh routine
extern int       RefreshMinutes=15;
extern bool      ShowRefreshComment=true;

static int       TF ; //= PERIOD_H1;
extern int       Redraw_Bars = 24;
//---- buffers

double EURMapBuffer1[];
double USDMapBuffer1[];
double JPYMapBuffer1[];
double GBPMapBuffer1[];
double CADMapBuffer1[];
double CHFMapBuffer1[];
double AUDMapBuffer1[];
double NZDMapBuffer1[];

//sry used to hold coef of MA calculations-for each currency
double EURCoeff_Array[];
double USDCoeff_Array[];
double JPYCoeff_Array[];
double GBPCoeff_Array[];
double CADCoeff_Array[];
double CHFCoeff_Array[];
double AUDCoeff_Array[];
double NZDCoeff_Array[];

string symbols[MAX_CPAIRS]={

   "EURUSD",
   "USDJPY",
   "GBPUSD",
   "USDCAD",
   "USDCHF",
   "AUDUSD",
   "NZDUSD",
   
   "EURJPY",
   "EURGBP",
   "EURCAD",
   "EURCHF",
   "EURAUD",
   "EURNZD",
   
   "GBPJPY",
   "CADJPY",
   "CHFJPY",
   "AUDJPY",
   "NZDJPY",
   
   "GBPCAD",
   "GBPCHF",
   "GBPAUD",
   "GBPNZD",
   
   "CADCHF",
   "AUDCAD",
   "NZDCAD",
   
   "AUDCHF",
   "NZDCHF",
   
   "AUDNZD",

   "_QM",//Oil
   
   "GOLD"

   };
string   CName[]={
         "EUR",
         "USD",
         "JPY",
         "GBP",
         "CAD",
         "CHF",
         "AUD",
         "NZD",
         "GOLD"};



double myarray[MAX_CPAIRS][3];//[5]; 
// 0=existance ; 1=cpp1 ; 2=cpp2 ; 3=buys_c_o_vol_cpp1 ; 4=buys_c_o_vol_cpp2 ;


string sname ; //= "Sentiment_All_V2_sry2_m1" ;

//sry used to automatically refresh rates
double MyRateArray[1440] [6];
bool FirstBar=true;
string mystr;//sry moved to variable global to all routines
int mystrctr;//sry moved to variable global to all routines
   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   TF = Period();

   sname = "Sentiment_all_v2_sry2_b_"+Symbol()+"_"+tf_sel() ;

  
   IndicatorShortName(sname);

   SetIndexStyle (EUR,DRAW_LINE,STYLE_SOLID,2,indicator_color[EUR]);
   SetIndexBuffer(EUR,EURMapBuffer1);
   SetIndexLabel (EUR,"EUR");

   SetIndexStyle (USD,DRAW_LINE,STYLE_SOLID,2,indicator_color[USD]);
   SetIndexBuffer(USD,USDMapBuffer1);
   SetIndexLabel (USD,"USD");

   SetIndexStyle (JPY,DRAW_LINE,STYLE_SOLID,2,indicator_color[JPY]);
   SetIndexBuffer(JPY,JPYMapBuffer1);
   SetIndexLabel (JPY,"JPY");

   SetIndexStyle (GBP,DRAW_LINE,STYLE_SOLID,2,indicator_color[GBP]);
   SetIndexBuffer(GBP,GBPMapBuffer1);
   SetIndexLabel (GBP,"GBP");

   SetIndexStyle (CAD,DRAW_LINE,STYLE_SOLID,2,indicator_color[CAD]);
   SetIndexBuffer(CAD,CADMapBuffer1);
   SetIndexLabel (CAD,"CAD");

   SetIndexStyle (CHF,DRAW_LINE,STYLE_SOLID,2,indicator_color[CHF]);
   SetIndexBuffer(CHF,CHFMapBuffer1);
   SetIndexLabel (CHF,"CHF");

   SetIndexStyle (AUD,DRAW_LINE,STYLE_SOLID,2,indicator_color[AUD]);
   SetIndexBuffer(AUD,AUDMapBuffer1);
   SetIndexLabel (AUD,"AUD");

   SetIndexStyle (NZD,DRAW_LINE,STYLE_SOLID,2,indicator_color[NZD]);
   SetIndexBuffer(NZD,NZDMapBuffer1);
   SetIndexLabel (NZD,"NZD");
//----

   SetLevelValue( 0, 0 ) ;
   SetLevelStyle( STYLE_DOT , 1 , Silver ) ;

   ArraySetAsSeries(MyRateArray,true);

  ArraySetAsSeries(EURCoeff_Array,true);
  ArraySetAsSeries(USDCoeff_Array,true);
  ArraySetAsSeries(JPYCoeff_Array,true);
  ArraySetAsSeries(GBPCoeff_Array,true);
  ArraySetAsSeries(CADCoeff_Array,true);
  ArraySetAsSeries(CHFCoeff_Array,true);
  ArraySetAsSeries(AUDCoeff_Array,true);
  ArraySetAsSeries(NZDCoeff_Array,true);

   int i , j;
   

//sry Compensate for ibx broker (uses suffix 'm' on mini accounts)
string addchar;
if (StringLen(Symbol())>6) {
   addchar=StringSubstr(Symbol(),6);
   for (i=0;i<MAX_CPAIRS; i++) {
       if (StringLen(symbols[i])==6) symbols[i]=symbols[i]+addchar;
   }          
}

FirstBar=true;

   

   for( i=0 ; i<MAX_CPAIRS ; i++ ) 
      {
      if ( ( MarketInfo( symbols[i] , MODE_TRADEALLOWED )) 
        || ( iVolume( symbols[i] , Period() , 1 ) != 0 ) 
        || ( iVolume( symbols[i] , Period() , 2 ) != 0 )) 
        {
        myarray[i][0] = 1 ;

       for (int k=0;k<=9;k++) {
          int l=StringFind(symbols[i],CName[k]);
          if  (l==0) myarray[i][1]=k;//base currency
          if  (l==3) myarray[i][2]=k;//counter currency
      }
// special case - oil and gold
      myarray[28][2]=USD;
      myarray[29][2]=USD;

      }
   }

   mystr = " \n";
   mystrctr = 0;

   for (i=0;i<MAX_CPAIRS;i++) {
     if (myarray[i][0]==1) {
        mystr=StringConcatenate(mystr,symbols[i]," ,");
        mystrctr++;
        if (mystrctr % 7 ==0) mystr=StringConcatenate(mystr," \n");
     }   
   }
  
   mystr = mystr + " ...total cpairs= " + DoubleToStr( mystrctr, 0) ; /* +
    "\n Bars= " + DoubleToStr( Bars , 0) + " ,counted_bars = " + DoubleToStr( counted_bars , 0) + " ,limit= " + DoubleToStr( limit , 0) ;*/

if (History<=0) History=Bars-MA_Per;//ensure there are enough calculations for MA_Per 
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
  {
//----
//Clean up - delete all objects created by this indicator
  ObjectsDeleteAll(WindowFind(sname));

 
   
//----
   return(0);
 }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
 
   int    i , j , k , l , limit , counted_bars  ;
   double c_o , h_l , v , med , sign ;
   counted_bars = IndicatorCounted() ;
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit = Bars-counted_bars;
   if ( limit > (History+MA_Per) ) limit = History+MA_Per;
   else limit += Redraw_Bars;
   
   
   if (FirstBar)   {

#define First_Loc 475
    if ( WindowFind(sname) != -1 ) {
      for (i=0;i<8;i++) {
string Cnamei=sname+CName[i];      
        ObjectCreate(Cnamei, OBJ_LABEL, WindowFind(sname), 0, 0);
        ObjectSetText(Cnamei,CName[i],12, "Arial Bold");
        ObjectSet(Cnamei, OBJPROP_COLOR, indicator_color[i]);
        ObjectSet(Cnamei, OBJPROP_CORNER, 0);
        ObjectSet(Cnamei, OBJPROP_XDISTANCE, First_Loc+i*40);
        ObjectSet(Cnamei, OBJPROP_YDISTANCE, 3);
      }       
    }  

    Comment ( mystr );//sry I only display pair list once -
    FirstBar=false;
   }    

   if ( limit < 0 ) return(0);

   if ( MA_Per < 1 ) MA_Per = 1 ;
   if ( Flt_Per < 1 ) Flt_Per = 1 ; 
   if ( Candle_Back < 1 ) Candle_Back = 1;
   
 if (NewBar()) {
  if  (ArrayRange(EURCoeff_Array,0)<Bars) ArrayResize(EURCoeff_Array,Bars);
  if  (ArrayRange(USDCoeff_Array,0)<Bars) ArrayResize(USDCoeff_Array,Bars);
  if  (ArrayRange(JPYCoeff_Array,0)<Bars) ArrayResize(JPYCoeff_Array,Bars);
  if  (ArrayRange(GBPCoeff_Array,0)<Bars) ArrayResize(GBPCoeff_Array,Bars);
  if  (ArrayRange(CADCoeff_Array,0)<Bars) ArrayResize(CADCoeff_Array,Bars);
  if  (ArrayRange(CHFCoeff_Array,0)<Bars) ArrayResize(CHFCoeff_Array,Bars);
  if  (ArrayRange(AUDCoeff_Array,0)<Bars) ArrayResize(AUDCoeff_Array,Bars);
  if  (ArrayRange(NZDCoeff_Array,0)<Bars) ArrayResize(NZDCoeff_Array,Bars);
 }
 
 for ( i = limit ; i >= 0 ; i -- )  { // level 1
   EURMapBuffer1[i]=0;
   USDMapBuffer1[i]=0;
   JPYMapBuffer1[i]=0;
   GBPMapBuffer1[i]=0;
   CADMapBuffer1[i]=0;
   CHFMapBuffer1[i]=0;
   AUDMapBuffer1[i]=0;
   NZDMapBuffer1[i]=0;
  
//sry Prepare to use iMAOnArray Function to calculation coefficient just once per bar
  // for ( j = i + MA_Per - 1 ; j >= i ; j -- ) { // level 2

 
 //Calculate Coeff for MA

   j=i;
 
   EURCoeff_Array[j]=0;
   USDCoeff_Array[j]=0;
   JPYCoeff_Array[j]=0;
   GBPCoeff_Array[j]=0;
   CADCoeff_Array[j]=0;
   CHFCoeff_Array[j]=0;
   AUDCoeff_Array[j]=0;
   NZDCoeff_Array[j]=0;


     // 0=existance ; 1=cpp1 ; 2=cpp2; 


    for ( k = 0 ; k < MAX_CPAIRS ; k ++ ) { // level 3
      if ( myarray[k][0] == 1 ) { // level 4
      string symbolsk=symbols[k];// sry

       //med = ( iHigh(symbolsk , Period() , j ) + iLow(symbolsk , Period() , j ) + iClose(symbolsk , Period() , j ) ) / 3 ;

       c_o = ( iClose(symbolsk , TF , j ) - iOpen(symbolsk , TF , j+Candle_Back ) ) ;
       double myHigh = iHigh(symbolsk , TF , iHighest(symbolsk , TF , MODE_HIGH , Candle_Back , j ) );
       double myLow  = iLow (symbolsk , TF , iLowest (symbolsk , TF , MODE_LOW , Candle_Back , j ) );
       //h_l = (  iHigh(symbolsk , Period() , j ) - iLow(symbolsk , Period() , j+Candle_Back )  ) ;
       h_l = myHigh - myLow ;
         
       sign = 1 ; if ( c_o < 0 ) sign = -1 ;
         
       v = 0 ;
       for ( l = 0 ; l < Candle_Back ; l ++ ) v += ( iVolume(symbolsk , TF , j+l ) ) ;
       int spreadx = MarketInfo( symbolsk , MODE_SPREAD ) ;
       double pointx = MarketInfo( symbolsk , MODE_POINT ) ;
       if ( h_l == 0 ) h_l = pointx ;
       if      ( c_o >  spreadx * pointx / 1 ) c_o = c_o - spreadx * pointx / 1 ;
       else if ( c_o < -spreadx * pointx / 1 ) c_o = c_o + spreadx * pointx / 1 ;
       else                                    c_o = 0 ;

       c_o /= h_l ;

double myarrayk3=c_o*v; //division no longer needed since using iMAOnArray fuction  /MA_Per;
                       // also got rid of unnecessary calculations
// special case - oil and gold

      if (k==28) myarrayk3 *= 5000/100000;// oil
      if (k==29) myarrayk3 *=  100/100000;// gold


       
         
       if ( myarray[k][1] == EUR ) EURCoeff_Array[j] += myarrayk3;
       if ( myarray[k][2] == EUR ) EURCoeff_Array[j] -= myarrayk3;

       if ( myarray[k][1] == USD ) USDCoeff_Array[j] += myarrayk3;
       if ( myarray[k][2] == USD ) USDCoeff_Array[j] -= myarrayk3;

       if ( myarray[k][1] == JPY ) JPYCoeff_Array[j] += myarrayk3;
       if ( myarray[k][2] == JPY ) JPYCoeff_Array[j] -= myarrayk3;

       if ( myarray[k][1] == GBP ) GBPCoeff_Array[j] += myarrayk3;
       if ( myarray[k][2] == GBP ) GBPCoeff_Array[j] -= myarrayk3;

       if ( myarray[k][1] == CAD ) CADCoeff_Array[j] += myarrayk3;
       if ( myarray[k][2] == CAD ) CADCoeff_Array[j] -= myarrayk3;
      
       if ( myarray[k][1] == CHF ) CHFCoeff_Array[j] += myarrayk3;
       if ( myarray[k][2] == CHF ) CHFCoeff_Array[j] -= myarrayk3;

       if ( myarray[k][1] == AUD ) AUDCoeff_Array[j] += myarrayk3;
       if ( myarray[k][2] == AUD ) AUDCoeff_Array[j] -= myarrayk3;

       if ( myarray[k][1] == NZD ) NZDCoeff_Array[j] += myarrayk3;
       if ( myarray[k][2] == NZD ) NZDCoeff_Array[j] -= myarrayk3;
       } // level 4 end

    } // level 3 end
      
//  }  // j MA level 2 end

if (i<=History) {//sry Don't bother to calculate unless there are at least MA_Per data points
                 //this was assured do the the way History was set durining init

     EURMapBuffer1[i]=iMAOnArray(EURCoeff_Array,0,MA_Per,0,MODE_SMA,j);
     USDMapBuffer1[i]=iMAOnArray(USDCoeff_Array,0,MA_Per,0,MODE_SMA,j);
     JPYMapBuffer1[i]=iMAOnArray(JPYCoeff_Array,0,MA_Per,0,MODE_SMA,j);
     GBPMapBuffer1[i]=iMAOnArray(GBPCoeff_Array,0,MA_Per,0,MODE_SMA,j);
     CADMapBuffer1[i]=iMAOnArray(CADCoeff_Array,0,MA_Per,0,MODE_SMA,j);
     CHFMapBuffer1[i]=iMAOnArray(CHFCoeff_Array,0,MA_Per,0,MODE_SMA,j);
     AUDMapBuffer1[i]=iMAOnArray(AUDCoeff_Array,0,MA_Per,0,MODE_SMA,j);
     NZDMapBuffer1[i]=iMAOnArray(NZDCoeff_Array,0,MA_Per,0,MODE_SMA,j);


   if ( i < limit - Flt_Per )
      for ( j = Flt_Per-1 ; j >= 0 ; j -- ) { //level 2
         EURMapBuffer1[i] += EURMapBuffer1[i+j] / Flt_Per ;
         USDMapBuffer1[i] += USDMapBuffer1[i+j] / Flt_Per ;
         JPYMapBuffer1[i] += JPYMapBuffer1[i+j] / Flt_Per ;
         GBPMapBuffer1[i] += GBPMapBuffer1[i+j] / Flt_Per ;
         CADMapBuffer1[i] += CADMapBuffer1[i+j] / Flt_Per ;
         CHFMapBuffer1[i] += CHFMapBuffer1[i+j] / Flt_Per ;
         AUDMapBuffer1[i] += AUDMapBuffer1[i+j] / Flt_Per ;
         NZDMapBuffer1[i] += NZDMapBuffer1[i+j] / Flt_Per ;
      } //level 2 end
     sign = 1 ; if ( EURMapBuffer1[i] < 0 ) sign = -1 ; EURMapBuffer1[i] = sign * MathSqrt(sign * EURMapBuffer1[i]) ;
     sign = 1 ; if ( USDMapBuffer1[i] < 0 ) sign = -1 ; USDMapBuffer1[i] = sign * MathSqrt(sign * USDMapBuffer1[i]) ;
     sign = 1 ; if ( JPYMapBuffer1[i] < 0 ) sign = -1 ; JPYMapBuffer1[i] = sign * MathSqrt(sign * JPYMapBuffer1[i]) ;
     sign = 1 ; if ( GBPMapBuffer1[i] < 0 ) sign = -1 ; GBPMapBuffer1[i] = sign * MathSqrt(sign * GBPMapBuffer1[i]) ;
     sign = 1 ; if ( CADMapBuffer1[i] < 0 ) sign = -1 ; CADMapBuffer1[i] = sign * MathSqrt(sign * CADMapBuffer1[i]) ;
     sign = 1 ; if ( CHFMapBuffer1[i] < 0 ) sign = -1 ; CHFMapBuffer1[i] = sign * MathSqrt(sign * CHFMapBuffer1[i]) ;
     sign = 1 ; if ( AUDMapBuffer1[i] < 0 ) sign = -1 ; AUDMapBuffer1[i] = sign * MathSqrt(sign * AUDMapBuffer1[i]) ;
     sign = 1 ; if ( NZDMapBuffer1[i] < 0 ) sign = -1 ; NZDMapBuffer1[i] = sign * MathSqrt(sign * NZDMapBuffer1[i]) ;

//     if ( EURMapBuffer1[i] < 0 ) EURMapBuffer1[i] = -MathSqrt(-EURMapBuffer1[i]) 
//     else                        EURMapBuffer1[i] =  MathSqrt( EURMapBuffer1[i]) 

  }    
  } // i main indic //level 1 end


   
//----

//SRY use subroutine to force rates to refresh every 15 minutes
//moved to end of main loop - so only run if terminal allows the time (metatrader max of 2.5 seconds per tick.
 for (k=0;k<9;k++) { // value of k is arbitrary - to try not to overload processor
   if  (!IsStopped())  RefreshAllRates(RefreshMinutes, ShowRefreshComment);
   else break;
 }   
   
        string auxstr = tf_sel();
        ObjectCreate(auxstr , OBJ_LABEL, WindowFind(sname), 0, 0);
        ObjectSetText(auxstr ,auxstr+" "+TimeToStr(iTime(NULL,TF,0),TIME_MINUTES),12, "Arial Bold");
        ObjectSet(auxstr , OBJPROP_COLOR, White);
        ObjectSet(auxstr , OBJPROP_CORNER, 0);
        ObjectSet(auxstr , OBJPROP_XDISTANCE, 800);
        ObjectSet(auxstr , OBJPROP_YDISTANCE, 3);


 return(0);
  }
//+------------------------------------------------------------------+
 
//+--------------------------------------------------------------------------------------------   

int RefreshAllRates(int RefreshTF=15,bool ShowComment=true) {
// routine by Steven R. Young - 
// To Refresh all Chart Pairs - All Time Frams - Every 15 minutes
// Since Indicators and Experts are limited in how much time they should process
// only Refresh one Rate and one Time Frame - each time it is called
// then Don't again until next time started
//if (ArrayRange(MyRateArray,0)<Bars) ArrayResize(MyRateArray,Bars);

return (0);

static int tflist[]={1,5,15,30,60,240,1440,10080,43200};
static string tfdesc[]={"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
static datetime LastRefreshTime;
datetime TimeNow;

if (RefreshTF<1) RefreshTF=1;// this is really too often!
int i,j;

//Use Global Variables to Save indexs - so we  don't start over on each time frame changes
static string GVI="RefreshRates i";
static string GVJ="RefreshRates j";
static string GVT="RefreshRates time";
static string GVS="RefreshRates Semaphore";
//Make Sure Only One set of Subroutines is operating at a time;

if (!GlobalVariableCheck(GVS)) GlobalVariableSet(GVS,0);//check to be sure semaphore exists
if (GlobalVariableSetOnCondition(GVS,1,0)) {// set semaphore so other process will not run

  if (GlobalVariableCheck(GVI)) i=GlobalVariableGet(GVI); else i=0;
  if (GlobalVariableCheck(GVJ)) j=GlobalVariableGet(GVJ); else j=0;
  if (GlobalVariableCheck(GVT)) LastRefreshTime=GlobalVariableGet(GVJ); else LastRefreshTime=0;

  TimeNow=iTime(Symbol(),RefreshTF,0);
  if (i>=MAX_CPAIRS) { //see if need to start again
    if ( TimeNow==LastRefreshTime) return(0);
    else {
    i=0;j=0;
    LastRefreshTime=iTime(Symbol(),RefreshTF,0);  
    }
  }  
  if (j>=ArrayRange(tflist,0) ) {
     i++;
     j=0;
  }
   
  if (myarray[i][0]==1) {// first check for existance
//sry note: due to a bug in mt4, a comment from an indicator shows up in EVERY chart Window
//    whether you want it to or note: hence the option to turn it off.
  if (ShowComment==true) Comment("Refresh Rates at ",TimeToStr(TimeNow,TIME_MINUTES)," for Pair ",i," of ",MAX_CPAIRS," : ",symbols[i]," Time Frame:",tfdesc[j]);   
    int errno=ArrayCopyRates(MyRateArray,symbols[i],tflist[j]);
    if (errno==-1) Print("Refresh Rates Error:",GetLastError()," for Pair ",i," of ",MAX_CPAIRS,":",symbols[i]," Time Frame:",tfdesc[j]);   
    else j++;
  }
  else j=100;


//save values for next time around
  GlobalVariableSet(GVI,i);
  GlobalVariableSet(GVJ,j);
  GlobalVariableSet(GVT,LastRefreshTime);
  
  GlobalVariableSet(GVS,0);// reset semaphore

 }
 
return (1);
}       

//+--------------------------------------------------------------

bool NewBar()
{
   static datetime dt = 0;
   
   if (Time[0] != dt)
   {
      dt = Time[0];
      return(true);
   }
   return(false);
}

//////////////////////////////////////////////////////
  
string   tf_sel()
{
   if ( TF == PERIOD_M1 )  return ( "1M" );
   if ( TF == PERIOD_M5 )  return ( "5M" );
   if ( TF == PERIOD_M15 ) return ( "15M" );
   if ( TF == PERIOD_M30 ) return ( "30M" );
   if ( TF == PERIOD_H1 )  return ( "1H" );
   if ( TF == PERIOD_H4 )  return ( "4H" );
   if ( TF == PERIOD_D1 )  return ( "1D" );
   if ( TF == PERIOD_W1 )  return ( "1W" );
   if ( TF == PERIOD_MN1 ) return ( "1MON" );
   TF = PERIOD_H1;
   return ( "1H" );
} 

